<template>
  <v-container>
    <v-layout row wrap>
      <v-flex xs12 sm3 ma-2 v-for="student in students" :key="student.id">
        <v-card @click="selectStudent(student)" :dark="isSelected(student)">
          <v-card-title primary-title>{{student.email}}</v-card-title>
          <v-card-text>{{student.age}} yo</v-card-text>
        </v-card>
      </v-flex>
    </v-layout>
  </v-container>
</template>

<script>
import { mapState } from "vuex";

export default {
  
  computed: {
    ...mapState(["students"]),
    ...mapState({
      selected: state => state.studentSelect.selected
    })
  },
  mounted() {
    this.$store.dispatch("fetchStudents");
  },
  methods: {
    selectStudent(student) {
      if (!this.isSelected(student)) {
        this.$store.commit('studentSelect/SELECT', student);
      } else {
        this.$store.commit('studentSelect/DESELECT', student);
        
      }
      this.$emit('select', this.selected);
    },
    isSelected(student) {
      
      return this.selected.find(item => item.id === student.id) !== undefined;
      //return this.selected.findIndex(item => item.id === student.id) !== -1;

    }
  }
};
</script>

<style>
</style>
